#pragma once

#include "CoreMinimal.h"
#include "K36SpellInteraction.h"
#include "Templates/SubclassOf.h"
#include "K36MageHandSpellInteraction.generated.h"

class AK36MageHand;
class UK36MageHandPalletSelectionComponent;

UCLASS(Blueprintable, EditInlineNew, meta=(BlueprintSpawnableComponent))
class UK36MageHandSpellInteraction : public UK36SpellInteraction
{
	GENERATED_BODY()

private:
	UPROPERTY(EditAnywhere, BlueprintReadWrite, meta=(AllowPrivateAccess=true))
	TSubclassOf<AK36MageHand> _mageHandClass;

	UPROPERTY(EditAnywhere, BlueprintReadWrite, ReplicatedUsing=OnRep_MageHand, meta=(AllowPrivateAccess=true))
	AK36MageHand* _mageHand;

	UPROPERTY(EditAnywhere, BlueprintReadWrite, meta=(AllowPrivateAccess=true))
	TSubclassOf<UK36MageHandPalletSelectionComponent> _palletSelectionComponentClass;

	UPROPERTY(BlueprintReadWrite, Transient, Instanced, meta=(AllowPrivateAccess=true))
	UK36MageHandPalletSelectionComponent* _palletSelectionComponent;

private:
	UFUNCTION(BlueprintCallable)
	void OnRep_MageHand();

public:
	virtual void GetLifetimeReplicatedProps(TArray<FLifetimeProperty>& OutLifetimeProps) const override;

public:
	UK36MageHandSpellInteraction();
};

FORCEINLINE uint32 GetTypeHash(const UK36MageHandSpellInteraction) { return 0; }
